﻿Imports Telerik.Web.UI
Imports System.Data

Partial Class Temp_20140410_Default
    Inherits System.Web.UI.Page



    Protected Sub RadGrid1_NeedDataSource(sender As Object, e As GridNeedDataSourceEventArgs) Handles RadGrid1.NeedDataSource
        RadGrid1.DataSource = PopulateGrid
    End Sub

    Public Property PopulateGrid() As DataTable
        Get
            Dim data As DataTable

            If Session("GridData") Is Nothing Then
                data = GenerateData()

                Session("GridData") = data
            End If

            data = DirectCast(Session("GridData"), DataTable)

            Return data
        End Get

        Set(value As DataTable)
            Session("GridData") = value
        End Set
    End Property

    Public Function GenerateData() As DataTable
        Dim data As New DataTable()

        data.Columns.Add("ID", GetType(Integer))
        data.Columns.Add("Name")
        data.Columns.Add("Description")

        For i As Integer = 1 To 30
            data.Rows.Add(i, "Name" + (i Mod 5).ToString(), "Description" + i.ToString())
        Next

        Return data
    End Function

    Protected Sub RadGrid1_UpdateCommand(sender As Object, e As GridCommandEventArgs) Handles RadGrid1.UpdateCommand
        Dim argument As GridBatchEditingEventArgument = TryCast(e.CommandArgument, GridBatchEditingEventArgument)

        Dim editItem As GridEditableItem = TryCast(e.Item, GridEditableItem)


        Dim newData As DataTable = PopulateGrid

        Dim row As DataRow() = newData.Select("ID = " + editItem.OwnerTableView.DataKeyValues(editItem.ItemIndex)("ID").ToString())

        'row[0]["ID"] = argument.NewValues["ID"];
        row(0)("Name") = argument.NewValues("Name")
        row(0)("Description") = argument.NewValues("Description")

        newData.AcceptChanges()

        PopulateGrid = newData
    End Sub

    Protected Sub RadGrid1_InsertCommand(sender As Object, e As GridCommandEventArgs) Handles RadGrid1.InsertCommand
        Dim argument As GridBatchEditingEventArgument = TryCast(e.CommandArgument, GridBatchEditingEventArgument)

        'var editItem = e.Item as GridEditableItem;

        Dim newData As DataTable = PopulateGrid

        Dim row As DataRow = newData.NewRow()

        row("ID") = argument.NewValues("ID")
        row("Name") = argument.NewValues("Name")
        row("Description") = argument.NewValues("Description")

        newData.Rows.Add(row)

        PopulateGrid = newData
    End Sub

End Class
